//Four.Nine CATLIB Archive
#include <stdio.h>
#include <stdlib.h>
#include <alloc.h>
#include <string.h>

unsigned char	lzpmd[3] = { 0xFF, 0x00, 0x1A };
unsigned char	lzmmd[3] = { 0xFF, 0x3C, 0x00 };
char			*tmpname = "@@TMP@@.DAT";

unsigned long decodeLZ( FILE *in, unsigned long size, FILE *out )
{
	unsigned char	buf[256];
	unsigned char	*dic;
	unsigned long	dicpos = 0x0001;
	unsigned char	byte;
	unsigned char	sign;
	unsigned int	counter;
	unsigned int	decode_startaddr;
	unsigned int	decode_length;
	int				i;
	int				q;
	unsigned long	decode_byte = 0L;
	unsigned long	read_byte = 0L;
	unsigned long	addr = 0L;

	dic = ( unsigned char * )calloc( 1, 4096 );

	while( read_byte < size )
	{
		//compress sign
		fread( buf, 1, 1, in ); sign = buf[0];
		read_byte++;

		for( i = 0; i != 8; i++ )
		{
			if( sign & 1 )
			{
				fread( buf, 1, 1, in ); byte = buf[0];
				dic[dicpos] = byte;
				fprintf( out, "%c", byte );
				dicpos++; dicpos &= 0x0FFF;
				read_byte++; decode_byte++;
			} else {
				fread( buf, 2, 1, in ); counter = *( unsigned int *)( buf );
				decode_length = ( counter & 15 ) + 3;		//4bit
				decode_startaddr = ( counter >> 4 );		//12bit
				read_byte += 2;

				//decode
				for( q = 0; q != decode_length; q++ )
				{
					addr = decode_startaddr + q; addr &= 0x0FFF;
					dic[dicpos] = dic[addr];
					fprintf( out, "%c", dic[addr] );
					dicpos++; dicpos &= 0x0FFF;
					decode_byte++;
				}
			}
			sign >>= 1;
			if( read_byte > size ) break;
		}
	}
	free( dic );
	return decode_byte;
}

void main( int ac, char **av )
{
	FILE				*in;
	FILE				*out;
	unsigned char		tmp[12];
	unsigned char		*buf;
	unsigned char		*filebuf;
	unsigned long		header_length_compress = 0L;
	unsigned long		header_length_original = 0L;
	unsigned int		file_count = 0;
	unsigned long		file_ed = 0L;

	char				index_filename[12];
	char				header_filename[12];
	unsigned long		header_filest = 0L;
	unsigned long		header_fileed = 0L;
	unsigned long		header_filesize = 0L;

	unsigned long		nowsize = 0L;

	unsigned int		i;

	printf( "Four.Nine CAT/LIB Divider 060207 (c)Fac.KUROHANE\n" );

	if( ac == 1 )
	{
		printf( "usage: CATDIV <filename_dat>\n" );
		return;
	}

	//.CAT file
	strcpy( index_filename, av[1] );
	memcpy( &index_filename[strlen( index_filename ) - 3], "CAT", 3 );

	in = fopen( index_filename, "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", index_filename );
		return;
	}
	printf( "index_filename: %s\n", index_filename );

	fseek( in, 0x00, SEEK_SET );
	fread( tmp, 12, 1, in );
	if( memcmp( tmp, "Cat", 3 ))
	{
		printf( "error: not CAT/LIB format.\n" );
		goto end2;
	}

	//file_count
	file_count = *( unsigned int * )( tmp + 4 );
	printf( "file_count: %u\n", file_count );

	//filesize
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );

	//Header size
	header_length_compress = file_ed;
	printf( "header_length_compress: %lu(%04lX)\n",
		header_length_compress,
		header_length_compress
	);

	out = fopen( tmpname, "wb+" );
	if( in == NULL )
	{
		printf( "error: can't open tempfile\n" );
		goto end;
	}

	//CAT extract
	fseek( in , 6, SEEK_SET );
	header_length_original = decodeLZ( in, header_length_compress - 6, out );
	printf( "header_length_original: %lu(%04lX)\n",
		header_length_original,
		header_length_original
	);
	fclose( in );
	fclose( out );

	in = fopen( tmpname, "rb" );

	buf = ( unsigned char *)calloc( 1, header_length_original );
	fread( buf, header_length_original, 1, in );

	fclose( in );
	remove( tmpname );

	//.LIB file
	in = fopen( av[1], "rb" );
	if( in == NULL )
	{
		printf( "error: can't open %s\n", av[1] );
		return;
	}
	printf( "data_filename: %s\n", av[1] );

	//filesize
	fseek( in, 0, SEEK_END );
	file_ed = ftell( in );
	fseek( in, 0, SEEK_SET );

	printf( "file_size: %lu bytes\n", file_ed );
	printf( "\n" );

	for( i = 0; i != file_count; i++ )
	{
		memset( header_filename, 0, sizeof( header_filename ) + 1 );
		memcpy( header_filename, &buf[i*0x16], 12 );

		header_filest = *( unsigned long *)( buf + ( i * 0x16 ) + 0x12 );
		header_filesize = *( unsigned long *)( buf + ( i * 0x16 ) + 0x0E );
		header_fileed = header_filest + header_filesize;

		printf( "%03d %-12s %08lX-%08lX (%lu) ",
			i + 1,
			header_filename,
			header_filest,
			header_fileed,
			header_filesize
		);

		out = fopen( header_filename, "wb+" );
		if( out == NULL )
		{
			printf( "error: can't write %s\n", header_filename );
			goto end;
		}

		fseek( in, header_filest + 10, SEEK_SET );
		fread( tmp, 3, 1, in );
		fseek( in, -3, SEEK_CUR );

		if( tmp[0] == 0xFF )	//LZ?
		{
			//decode
			nowsize = decodeLZ( in, header_filesize, out );
			printf( " -> (%lu)", nowsize );
		} else {
			filebuf = ( unsigned char * )calloc( 1, header_filesize );
			fread( filebuf, header_filesize, 1, in );
			fwrite( filebuf, header_filesize, 1, out );
			free( filebuf );
		}
		printf( "\n" );
		fclose( out );
	}

	printf( "\n" );
	printf( "complete.\n" );

end:;
	free( buf );
end2:;
	fclose( in );
	return;
}
